module.exports =
/******/ (function(modules) { // webpackBootstrap
/******/ 	// The module cache
/******/ 	var installedModules = {};
/******/
/******/ 	// The require function
/******/ 	function __webpack_require__(moduleId) {
/******/
/******/ 		// Check if module is in cache
/******/ 		if(installedModules[moduleId]) {
/******/ 			return installedModules[moduleId].exports;
/******/ 		}
/******/ 		// Create a new module (and put it into the cache)
/******/ 		var module = installedModules[moduleId] = {
/******/ 			i: moduleId,
/******/ 			l: false,
/******/ 			exports: {}
/******/ 		};
/******/
/******/ 		// Execute the module function
/******/ 		modules[moduleId].call(module.exports, module, module.exports, __webpack_require__);
/******/
/******/ 		// Flag the module as loaded
/******/ 		module.l = true;
/******/
/******/ 		// Return the exports of the module
/******/ 		return module.exports;
/******/ 	}
/******/
/******/
/******/ 	// expose the modules object (__webpack_modules__)
/******/ 	__webpack_require__.m = modules;
/******/
/******/ 	// expose the module cache
/******/ 	__webpack_require__.c = installedModules;
/******/
/******/ 	// define getter function for harmony exports
/******/ 	__webpack_require__.d = function(exports, name, getter) {
/******/ 		if(!__webpack_require__.o(exports, name)) {
/******/ 			Object.defineProperty(exports, name, { enumerable: true, get: getter });
/******/ 		}
/******/ 	};
/******/
/******/ 	// define __esModule on exports
/******/ 	__webpack_require__.r = function(exports) {
/******/ 		if(typeof Symbol !== 'undefined' && Symbol.toStringTag) {
/******/ 			Object.defineProperty(exports, Symbol.toStringTag, { value: 'Module' });
/******/ 		}
/******/ 		Object.defineProperty(exports, '__esModule', { value: true });
/******/ 	};
/******/
/******/ 	// create a fake namespace object
/******/ 	// mode & 1: value is a module id, require it
/******/ 	// mode & 2: merge all properties of value into the ns
/******/ 	// mode & 4: return value when already ns object
/******/ 	// mode & 8|1: behave like require
/******/ 	__webpack_require__.t = function(value, mode) {
/******/ 		if(mode & 1) value = __webpack_require__(value);
/******/ 		if(mode & 8) return value;
/******/ 		if((mode & 4) && typeof value === 'object' && value && value.__esModule) return value;
/******/ 		var ns = Object.create(null);
/******/ 		__webpack_require__.r(ns);
/******/ 		Object.defineProperty(ns, 'default', { enumerable: true, value: value });
/******/ 		if(mode & 2 && typeof value != 'string') for(var key in value) __webpack_require__.d(ns, key, function(key) { return value[key]; }.bind(null, key));
/******/ 		return ns;
/******/ 	};
/******/
/******/ 	// getDefaultExport function for compatibility with non-harmony modules
/******/ 	__webpack_require__.n = function(module) {
/******/ 		var getter = module && module.__esModule ?
/******/ 			function getDefault() { return module['default']; } :
/******/ 			function getModuleExports() { return module; };
/******/ 		__webpack_require__.d(getter, 'a', getter);
/******/ 		return getter;
/******/ 	};
/******/
/******/ 	// Object.prototype.hasOwnProperty.call
/******/ 	__webpack_require__.o = function(object, property) { return Object.prototype.hasOwnProperty.call(object, property); };
/******/
/******/ 	// __webpack_public_path__
/******/ 	__webpack_require__.p = "";
/******/
/******/
/******/ 	// Load entry module and return exports
/******/ 	return __webpack_require__(__webpack_require__.s = "./src/index.ts");
/******/ })
/************************************************************************/
/******/ ({

/***/ "./src/file-editor-input-registry.ts":
/*!*******************************************!*\
  !*** ./src/file-editor-input-registry.ts ***!
  \*******************************************/
/*! no static exports found */
/***/ (function(module, exports, __webpack_require__) {

"use strict";

Object.defineProperty(exports, "__esModule", { value: true });
const client_core_1 = __webpack_require__(/*! @common-stack/client-core */ "@common-stack/client-core");
const core_1 = __webpack_require__(/*! @files-stack/core */ "@files-stack/core");
const client_state_1 = __webpack_require__(/*! @files-stack/client-state */ "@files-stack/client-state");
class FileEditorInputFactory {
    getFileDetails(resource, container) {
        const utility = container.get(client_core_1.ClientTypes.UtilityClass);
        const cache = container.get(client_core_1.ClientTypes.InMemoryCache);
        const id = utility.getCacheKey({ resource, __typename: "FileStatWithMetadata" });
        const file = cache.readFragment({
            id,
            fragment: core_1.EditorsFileRefFragmentDoc,
            variables: { skipValue: true },
        });
        return file;
    }
    createInput(resource, label, encoding, mode, container) {
        const fileStat = this.getFileDetails(resource, container);
        const pinned = false;
        const result = Object.assign({
            isPinned: pinned || false,
            closable: true,
            preview: false,
            isActive: false,
        }, {
            __typename: "FileEditorInput",
            id: null,
            description: label,
            typeId: "file",
            editorId: 1,
            resource: client_state_1.resourcePath(resource),
            preferredEncoding: encoding || fileStat.encoding,
            preferredMode: mode || fileStat.preferredMode,
            encoding: fileStat.encoding,
            mode: fileStat.preferredMode,
            fileReference: fileStat,
        });
        return result;
    }
}
exports.FileEditorInputFactory = FileEditorInputFactory;


/***/ }),

/***/ "./src/files.contribution.tsx":
/*!************************************!*\
  !*** ./src/files.contribution.tsx ***!
  \************************************/
/*! no static exports found */
/***/ (function(module, exports, __webpack_require__) {

"use strict";

var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (Object.hasOwnProperty.call(mod, k)) result[k] = mod[k];
    result["default"] = mod;
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
const React = __importStar(__webpack_require__(/*! react */ "react"));
const client_react_1 = __webpack_require__(/*! @files-stack/client-react */ "@files-stack/client-react");
const module_browser_1 = __webpack_require__(/*! @workbench-stack/module-browser */ "@workbench-stack/module-browser");
const platform_1 = __webpack_require__(/*! @vscode/monaco-editor/esm/vs/platform/registry/common/platform */ "@vscode/monaco-editor/esm/vs/platform/registry/common/platform");
const core_1 = __webpack_require__(/*! @files-stack/core */ "@files-stack/core");
const client_core_1 = __webpack_require__(/*! @common-stack/client-core */ "@common-stack/client-core");
const file_editor_input_registry_1 = __webpack_require__(/*! ./file-editor-input-registry */ "./src/file-editor-input-registry.ts");
exports.FilesContribution = props => {
    platform_1.Registry.as(module_browser_1.ClientExtensions.Editors).registerEditor({
        id: client_react_1.TextResourceEditor.defaultProps.ID,
        name: client_react_1.TextResourceEditor.displayName,
    }, [{ __typename: "FileEditorInput" }]);
    platform_1.Registry.as(module_browser_1.ClientExtensions.EditorInputFactories)
        .registerEditorInputFactory("file", new file_editor_input_registry_1.FileEditorInputFactory());
    platform_1.Registry.as(module_browser_1.ClientExtensions.EditorInputFactories).registerFileInputFactory({
        createFileInput: (resource, encoding, mode, container) => {
            const utility = container.get(client_core_1.ClientTypes.UtilityClass);
            const cache = container.get(client_core_1.ClientTypes.InMemoryCache);
            const id = utility.getCacheKey({ resource, __typename: "FileStatWithMetadata" });
            const file = cache.readFragment({
                id,
                fragment: core_1.EditorsFileRefFragmentDoc,
                variables: { skipValue: true },
            });
            return file;
        },
        isFileInput: (obj) => {
            return obj.__typename === "FileEditorInput";
        },
    });
    return (React.createElement(React.Fragment, null,
        React.createElement(client_react_1.TextResourceEditor, Object.assign({}, props))));
};


/***/ }),

/***/ "./src/index.ts":
/*!**********************!*\
  !*** ./src/index.ts ***!
  \**********************/
/*! no static exports found */
/***/ (function(module, exports, __webpack_require__) {

"use strict";

var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const module_1 = __importDefault(__webpack_require__(/*! ./module */ "./src/module.tsx"));
const client_react_1 = __webpack_require__(/*! @common-stack/client-react */ "@common-stack/client-react");
const module_browser_1 = __importDefault(__webpack_require__(/*! @ide-layout/module-browser */ "@ide-layout/module-browser"));
const files_contribution_1 = __webpack_require__(/*! ./files.contribution */ "./src/files.contribution.tsx");
exports.FilesContribution = files_contribution_1.FilesContribution;
exports.default = new client_react_1.Feature(module_1.default, module_browser_1.default);


/***/ }),

/***/ "./src/module.tsx":
/*!************************!*\
  !*** ./src/module.tsx ***!
  \************************/
/*! no static exports found */
/***/ (function(module, exports, __webpack_require__) {

"use strict";

var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (Object.hasOwnProperty.call(mod, k)) result[k] = mod[k];
    result["default"] = mod;
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
const React = __importStar(__webpack_require__(/*! react */ "react"));
const client_react_1 = __webpack_require__(/*! @common-stack/client-react */ "@common-stack/client-react");
const client_react_2 = __webpack_require__(/*! @files-stack/client-react */ "@files-stack/client-react");
const client_state_1 = __webpack_require__(/*! @files-stack/client-state */ "@files-stack/client-state");
const client_state_2 = __webpack_require__(/*! @files-stack/client-state */ "@files-stack/client-state");
const core_1 = __webpack_require__(/*! @files-stack/core */ "@files-stack/core");
const client_react_3 = __webpack_require__(/*! @ide-layout/client-react */ "@ide-layout/client-react");
const module_browser_1 = __webpack_require__(/*! @workbench-stack/module-browser */ "@workbench-stack/module-browser");
const actionFunctions = [client_state_1.setRootPath];
const filesServiceGen = (container) => {
    return {
        fileService: container.get(core_1.ClientTypes.IFileService),
        textFileService: container.get(core_1.ClientTypes.ITextFileService),
        filesTreeService: container.get(core_1.ClientTypes.IFilesTreeService),
        untitledEditorService: container.get(core_1.ClientTypes.IUntitledEditorService),
        textFileEditorModel: container.get(core_1.ClientTypes.ITextFileEditorModel),
    };
};
const Content = ({ input }) => {
    console.log('--Content Component should only render once per input', input);
    let props = {};
    return React.createElement(module_browser_1.Editor, Object.assign({}, props, { input: input, uri: input.resource, enableApi: true }));
};
exports.default = new client_react_1.Feature({
    leftMainPanelItems: { files: React.createElement(client_react_2.Files, null) },
    middleMainPanelItems: { editors: React.createElement(client_react_3.DockLayout, { contentComponent: Content }) },
    middleMainPanelItemsProps: { editors: { actionFunctions } },
    reducer: Object.assign({}, client_state_1.reducers),
    createContainerFunc: client_state_1.filesModule,
    clientStateParams: [{ resolvers: [client_state_2.filesResolvers, client_state_2.editorResolvers, client_state_2.filesTreeResolvers], defaults: client_state_2.defaults,
            typeDefs: client_state_2.schema, fragmentMatcher: client_state_2.fragmentMatcher }],
    dataIdFromObject: client_state_2.dataIdFromObject,
    createServiceFunc: filesServiceGen,
    epic: [client_state_2.modelContentChangeEpic, client_state_2.modelSaveEpic],
});


/***/ }),

/***/ "@common-stack/client-core":
/*!********************************************!*\
  !*** external "@common-stack/client-core" ***!
  \********************************************/
/*! no static exports found */
/***/ (function(module, exports) {

module.exports = require("@common-stack/client-core");

/***/ }),

/***/ "@common-stack/client-react":
/*!*********************************************!*\
  !*** external "@common-stack/client-react" ***!
  \*********************************************/
/*! no static exports found */
/***/ (function(module, exports) {

module.exports = require("@common-stack/client-react");

/***/ }),

/***/ "@files-stack/client-react":
/*!********************************************!*\
  !*** external "@files-stack/client-react" ***!
  \********************************************/
/*! no static exports found */
/***/ (function(module, exports) {

module.exports = require("@files-stack/client-react");

/***/ }),

/***/ "@files-stack/client-state":
/*!********************************************!*\
  !*** external "@files-stack/client-state" ***!
  \********************************************/
/*! no static exports found */
/***/ (function(module, exports) {

module.exports = require("@files-stack/client-state");

/***/ }),

/***/ "@files-stack/core":
/*!************************************!*\
  !*** external "@files-stack/core" ***!
  \************************************/
/*! no static exports found */
/***/ (function(module, exports) {

module.exports = require("@files-stack/core");

/***/ }),

/***/ "@ide-layout/client-react":
/*!*******************************************!*\
  !*** external "@ide-layout/client-react" ***!
  \*******************************************/
/*! no static exports found */
/***/ (function(module, exports) {

module.exports = require("@ide-layout/client-react");

/***/ }),

/***/ "@ide-layout/module-browser":
/*!*********************************************!*\
  !*** external "@ide-layout/module-browser" ***!
  \*********************************************/
/*! no static exports found */
/***/ (function(module, exports) {

module.exports = require("@ide-layout/module-browser");

/***/ }),

/***/ "@vscode/monaco-editor/esm/vs/platform/registry/common/platform":
/*!*********************************************************************************!*\
  !*** external "@vscode/monaco-editor/esm/vs/platform/registry/common/platform" ***!
  \*********************************************************************************/
/*! no static exports found */
/***/ (function(module, exports) {

module.exports = require("@vscode/monaco-editor/esm/vs/platform/registry/common/platform");

/***/ }),

/***/ "@workbench-stack/module-browser":
/*!**************************************************!*\
  !*** external "@workbench-stack/module-browser" ***!
  \**************************************************/
/*! no static exports found */
/***/ (function(module, exports) {

module.exports = require("@workbench-stack/module-browser");

/***/ }),

/***/ "react":
/*!************************!*\
  !*** external "react" ***!
  \************************/
/*! no static exports found */
/***/ (function(module, exports) {

module.exports = require("react");

/***/ })

/******/ });
//# sourceMappingURL=index.js.map